﻿interface I1 {
	public int m1(int a, int b);
}

class A : I1 {
	public int m1(int a, int b) {
		return a + b;
	}
}

class B1 {
	public int m1(int a, int b) {
		return a + b + 1000;
	}
}

class B2 : B1, I1 {}

partial class Program {
	static void Main() {
		// Error: Cannot create an instance of the abstract type or interface 'I1'
		// I1 i = new I1();

		I1 i1 = new A();
		Console.WriteLine($"i1.m1(10, 20): {i1.m1(10, 20)}");

		// Error: Cannot implicitly convert type 'B1' to 'I1'.An explicit conversion exists(are you missing a cast?)
		// i1 = new B1();

		i1 = new B2();
		Console.WriteLine($"i1.m1(10, 20): {i1.m1(10, 20)}");

		i1 = new C1();
		Console.WriteLine($"i1.m1(10, 20): {i1.m1(10, 20)}");

		C2 c2 = new C2();
		Console.WriteLine($"c2.m1(10, 20): {c2.m1(10, 20)}");
		i1 = c2;
		Console.WriteLine($"i1.m1(10, 20): {i1.m1(10, 20)}");

		i1 = new C3();
		Console.WriteLine($"i1.m1(10, 20): {i1.m1(10, 20)}");
	}
}

class C1 : I1 {
	public int m1(int a, int b) {
		return a + b + 2000;
	}
}

class C2 : C1 {
	public new int m1(int a, int b) {
		return a / b;
	}
}

class C3 : C1, I1 {
	public new int m1(int a, int b) {
		return a - b;
	}
}
